#ifndef CLASSLIB_SCREEN_STRING_H
#define CLASSLIB_SCREEN_STRING_H

#include <stringc.h>
#include <array.h>

extern int LineLength(char *str,int n);

typedef struct screen_word
{
	String str;
	int x, y, dx, dy, pos, line;
} ssw;

class ScreenString
{
private:
	String string;
	Array<ssw> words;
public:
	int x, y, dx, dy;
	//static int FontHeight, LineSpacing,
	static int SpaceWidth, MaxWidth, MaxLines;
	int numLines;

	ScreenString (String &str, int xPos, int yPos): x(xPos), y (yPos) { SetString (str); };
	~ScreenString () {words.Clear ();};

	void Move (int newx, int newy) {x = newx; y = newy;};
	void SetString (String &str);
	String GetString ();
	String GetStringFromLine (int line);
	ScreenString GetScreenStringLine (int line);
	String GetStringFirstLine ();
	String GetWord (int x, int y);
	int numWords () {return words.GetSize ();}
	int GetCaretX (int pos);
	int GetCaretY (int pos);
	ScreenString& operator = (ScreenString& str);

	bool Visible ();
	bool FullyVisible ();
};

#endif

